typedef struct {
  int is_empty;
  int is_leaf;
  int element;  
  tree_t* left_son; 
  tree_t* right_son; 
} tree_t; 


tree_t* make_empty(int value) {
  tree_t* tree;
  tree = malloc(sizeof(tree_t));
  (*tree).is_empty = true;
  return tree;
}


tree_t* make_leaf(int value) {
  tree_t* tree;
  tree = malloc(sizeof(tree_t));
  (*tree).is_leaf = true;
  (*tree).element = value;
  return tree;
}


void insert(tree_t* tree, int value) {
  if((*tree).is_empty == true) {
      (*tree).is_empty = false;
      (*tree).is_leaf = true;
      (*tree).value = value;
    }
  else
    {
      if(value<(*tree).element)
	{
	  if((*tree).is_leaf == true)
	    (*tree).left_son = make_leaf(value);
	  else
	    insert((*tree).left_son, value);
	}
      else
	{
	  if((*tree).is_leaf == true)
	    (*tree).right_son = make_leaf(value);
	  else
	    insert((*tree).right_son, value);
	}
    }
}


int main(personnel_t bd)
{
  int[5] tab;
  int i;
  tree_t* tree;

  //Elements to be inserted
  tab[0] = 3;
  tab[1] = 8;
  tab[2] = 7;
  tab[3] = 4;
  tab[4] = 2;
  tab[5] = 9;

  //Build the binary search tree.
  tree = make_empty();
  for(i=0; i<5; i++)
    insert(tree,tab[i]);    
}
